/* -*- C++ -*-

  $Id: OvalTool.h,v 1.4 2001/02/13 15:31:15 neundorf Exp $

  This file is part of KIllustrator.
  Copyright (C) 1998 Kai-Uwe Sattler (kus@iti.cs.uni-magdeburg.de)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Library General Public License as
  published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU Library General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef OvalTool_h_
#define OvalTool_h_

#include <Tool.h>

class GOval;

class OvalTool : public Tool {
public:
  OvalTool (CommandHistory* history);

  virtual void processEvent (QEvent* e, GDocument* doc, Canvas* canvas);
  virtual void activate (GDocument* doc, Canvas* canvas);

  virtual void configure ();

  void aroundFixedCenter (bool flag);
  bool aroundFixedCenter () const { return useFixedCenter; }

private:
  GOval* oval;
  bool useFixedCenter;
  Coord pos;
};

#endif
